#include "resource.h"
#include <Shlwapi.h>
#include <iostream>
#include <vector>

//TODO:comment
int fileMappingCreate(LPWSTR szFileName, HWND hListBox)
{
	int ERROR_CODE = 0;

	//HANDLE hFile = INVALID_HANDLE_VALUE;
	//HANDLE	hMapping = NULL;

	SendMessage(hListBox, LB_RESETCONTENT, 0, 0);

	//   :
	HANDLE hFile = CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		ERROR_CODE = 1;
	}

	//  
	HANDLE hMapping = CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);
	if (hMapping == NULL)
	{
		ERROR_CODE = 2;
	}

	DWORD dwFileSizeHigh;
	DWORD64 qwFileSize = GetFileSize(hFile, &dwFileSizeHigh);
	qwFileSize += (((DWORD64)dwFileSizeHigh) << 32);
	DWORD64 qwFileOffset = 0;

	CloseHandle(hFile);

	TCHAR bufferHex[60] = { 0 };
	SYSTEM_INFO sinf;
	GetSystemInfo(&sinf);

	char buffer[60] = { 0 };
	int count2 = 0;
	char bufferLine[44] = {' '};
	bufferLine[8] = ':';
	bufferLine[34] = '|';
	
	while (qwFileSize > 0)
	{
		// ,     
		DWORD dwBytesInBlock = sinf.dwAllocationGranularity;
		if (qwFileSize < sinf.dwAllocationGranularity)
		{
			dwBytesInBlock = (DWORD)qwFileSize;
		}

		const PBYTE dataPtr = (PBYTE)MapViewOfFile(hMapping, FILE_MAP_READ, (DWORD)(qwFileOffset >> 32), (DWORD)(qwFileOffset & 0xFFFFFFFF), dwBytesInBlock);
		if (dataPtr == NULL)
		{
			ERROR_CODE = 3;
			break;
		}

		for (DWORD dwByte = 0; dwByte < dwBytesInBlock; dwByte++)
		{
			//char hex2str[] = "0123456789ABCDEF";
			char hex2str[3] = { 0 };
			hex2str[0] = (dwByte >> 4) & 0xF;
			hex2str[1] = (dwByte >> 0) & 0xF;
			hex2str[2] = 0;

			strcat_s(bufferLine, hex2str);

			// TODO: isprint

			if (dwByte % 8 == 0) {
				/*sprintf_s(buffer, "%08X", dwByte);
				words.append(buffer);
				words.append(": ");
				words.append("\t");*/
			}
			sprintf_s(buffer, "%02X", dataPtr[dwByte]);

			if (!strcmp(buffer, "0D") ||//TODO:rm rf
				!strcmp(buffer, "0A") ||
				!strcmp(buffer, "00") ||
				!strcmp(buffer, "01") ||
				!strcmp(buffer, "02") ||
				!strcmp(buffer, "03") ||
				!strcmp(buffer, "04") ||
				!strcmp(buffer, "05") ||
				!strcmp(buffer, "06") ||
				!strcmp(buffer, "07") ||
				!strcmp(buffer, "08") ||
				!strcmp(buffer, "09") ||
				!strcmp(buffer, "0B") ||
				!strcmp(buffer, "0C")) {
				/*letters.append(".");*/
			}
			else {
				sprintf_s(buffer, "%c", dataPtr[dwByte]);
				/*letters.append(buffer);*/
			}

			sprintf_s(buffer, "%02X", dataPtr[dwByte]);

			/*words.append(buffer);
			words.append(" ");*/
			count2++;

			if (count2 == 8) {
				/*words.append("\t");
				words.append("|");
				words.append("\t");
				words.append(letters);
				SendMessageA(hListBox, LB_ADDSTRING, NULL, (LPARAM)words.c_str());
				words = "";
				letters = "";
				count2 = 0;*/
			}
		}

		//    
		UnmapViewOfFile(dataPtr);

		//        
		qwFileOffset += dwBytesInBlock;
		qwFileSize -= dwBytesInBlock;
	}

	CloseHandle(hFile);
	CloseHandle(hMapping);
	return ERROR_CODE;
}
