#pragma once

#include "resource.h"
#include <Shlwapi.h>
#include <string.h>
#include <iostream>
#include <vector>

//TODO:comment
BOOL fileMappingCreate(LPWSTR szFileName, HWND hListBox)
{	
	SendMessage(hListBox, LB_RESETCONTENT, 0, 0);

	//   :
	HANDLE hFile = CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) 
	{
		TCHAR error[260] = {};//TODO:of
		wsprintf(error, _T("    %s     "), szFileName);
		MessageBox(0, error, _T(""), MB_ICONERROR);
		return (FALSE);
	}

	//  
	HANDLE	hMapping = CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);
	if (hMapping == NULL) 
	{
		MessageBox(0, _T("   "), _T(""), MB_ICONERROR);
		CloseHandle(hFile);
		return NULL;
	}
	
	DWORD dwFileSizeHigh;
	__int64 qwFileSize = GetFileSize(hFile, &dwFileSizeHigh);//TODO:signed/unsigned
	qwFileSize += (((__int64)dwFileSizeHigh) << 32);
	__int64 qwFileOffset = 0;

	CloseHandle(hFile);

	TCHAR bufferHex[60] = {};
	SYSTEM_INFO sinf;
	GetSystemInfo(&sinf);

	char buffer[60] = {};
	int count2 = 0;

	std::string words = "";
	std::string letters = "";

	while (qwFileSize > 0)
	{
		// ,     
		DWORD dwBytesInBlock = sinf.dwAllocationGranularity;
		if (qwFileSize < sinf.dwAllocationGranularity) 
		{
			dwBytesInBlock = (DWORD)qwFileSize;
		}

		const PBYTE dataPtr = (PBYTE)MapViewOfFile(hMapping, FILE_MAP_READ, (DWORD)(qwFileOffset >> 32), (DWORD)(qwFileOffset & 0xFFFFFFFF),dwBytesInBlock);
		if (dataPtr == NULL) 
		{
			MessageBox(NULL, _T("  "), _T(""), MB_ICONERROR);
			CloseHandle(hMapping);
			return NULL;//TODO:  
		}
		
		for (DWORD dwByte = 0; dwByte < dwBytesInBlock; dwByte++)
		{	
			char hex2str[] = "0123456789ABCDEF";
			char s[3] = { 0 };
			s[0] = (0xCA >> 4) & 0xF;
			s[1] = (0xCA >> 0) & 0xF;
			s[2] = 0;

			// TODO: isprint

;			if (dwByte % 8 == 0) {
				sprintf_s(buffer, "%08X", dwByte);
				words.append(buffer);
				words.append(": ");
				words.append("\t");	
			}
			sprintf_s(buffer, "%02X", dataPtr[dwByte]);

			if (!strcmp(buffer ,"0D") ||//TODO:rm rf
				!strcmp(buffer, "0A") ||
				!strcmp(buffer, "00") ||
				!strcmp(buffer, "01") ||
				!strcmp(buffer, "02") ||
				!strcmp(buffer, "03") ||
				!strcmp(buffer, "04") || 
				!strcmp(buffer, "05") || 
				!strcmp(buffer, "06") || 
				!strcmp(buffer, "07") || 
				!strcmp(buffer, "08") || 
				!strcmp(buffer, "09") || 
				!strcmp(buffer, "0B") || 
				!strcmp(buffer, "0C")) {
				letters.append(".");
			}
			else {
				sprintf_s(buffer, "%c", dataPtr[dwByte]);
				letters.append(buffer);
			}

			sprintf_s(buffer, "%02X", dataPtr[dwByte]);

			words.append(buffer);
			words.append(" ");
			count2++;

			if (count2 == 8) {
				words.append("\t");
				words.append("|");
				words.append("\t");
				words.append(letters);
				SendMessageA(hListBox, LB_ADDSTRING, NULL, (LPARAM)words.c_str());
				words = "";
				letters = "";
				count2 = 0;
			}
		}

		//    
		UnmapViewOfFile(dataPtr);
		
		//        
		qwFileOffset += dwBytesInBlock;
		qwFileSize -= dwBytesInBlock;
	}

	CloseHandle(hMapping);
	return (TRUE);
}
