﻿#pragma once
//количество файлов для их сравнения
#define NUM_OF_FILES 2

//изначальная ширина окна
#define WIN_WIDTH 1800
//изначальная высота окна
#define WIN_HEIGHT 394

//сдвиг для отрисовки следующего байта/символа
#define X_SHIFT 25 
//максимальное кол-во линий, которое уместится на экран
#define MAX_COUNT_OF_LINES(Height) (((Height - 40) / 15) + 1)  

//кол-во байтов в одной линии (8)
#define LINE 8 
#define HEX_DIGITS "0123456789ABCDEF"
#define MAX_LOADSTRING 100 
#define MAX_BUFFER_SIZE 60

//высота шрифта в пикселях (кегль)
#define FONT_HEIGHT 15

//минимальное значение пикселей для прорисовки
#define MIN_PIXELS_TO_DRAW 450
#define EDIT_FILENAME_X(id,Width) (((Width) / NUM_OF_FILES) * (id))
#define EDIT_FILENAME_Y 0
#define EDIT_FILENAME_W(Width) (((Width) / NUM_OF_FILES) - 50)
#define EDIT_FILENAME_H 20

//отображение кнопки выбора первого файла
#define BTN_CHOOSE_X(id,Width) (((Width) / NUM_OF_FILES) * ((id) + 1) - 50)
#define BTN_CHOOSE_Y 0
#define BTN_CHOOSE_W 50
#define BTN_CHOOSE_H 20

//отображение кнопки выбора второго файла + вывод содержимого обоих файлов
#define BTN_COMPARE_X 0
#define BTN_COMPARE_Y 20
#define BTN_COMPARE_W(Width) (450)
#define BTN_COMPARE_H 20

//отображение кнопки предыдущего сравнения
#define BTN_COMPAREPREVIOUS_X 450
#define BTN_COMPAREPREVIOUS_Y 20
#define BTN_COMPAREPREVIOUS_W(Width) (450)
#define BTN_COMPAREPREVIOUS_H 20

//отображение кнопки следующего сравнения
#define BTN_COMPARENEXT_X 900
#define BTN_COMPARENEXT_Y 20
#define BTN_COMPARENEXT_W(Width) (450)
#define BTN_COMPARENEXT_H 20

//отображение кнопки выбора шрифта
#define BTN_FONT_X 1350
#define BTN_FONT_Y 20
#define BTN_FONT_W(Width) (450)
#define BTN_FONT_H 20

//определение (отображение) полосы прокрутки
#define SCROLL_X(id,Width) (((Width) / NUM_OF_FILES) * ((id) + 1) - 20)
#define SCROLL_Y 40 
#define SCROLL_W 20 
#define SCROLL_H(Height) ((Height) - 40)

//прорисовка линий
#define DEFAULT_LINE_Y 40
#define DEFAULT_LINE_HEX_X 90
#define DEFAULT_LINE_NUM_X 0 
#define DEFAULT_LINE_STICK_X 275 